/*
 * Overlist
 * Reference list generator for OVERSEER
 * by Roger Burton West <rburtonw@nyx.net>
 * GNUWare
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tkplayer.h>

void help()
{
  fprintf(stderr,"Usage: overlist dir {> outputfile}\n");
  fprintf(stderr,"See documentation for more info!\n");
}

int main(int argc,char *argv[])
{
  bool parm_ok=false;

  fprintf(stderr,"OVERLIST v0.1 by Roger Burton West <roger@firedrake.demon.co.uk>\n");

  if (argc == 2) {
    parm_ok=set_game_dir(argv[1]);
  }

  if (!parm_ok) {
    fprintf(stderr,"Run OVERLIST <game_dir>\n");
    return 1;
  }

  printf("Match list for CLASS:\n  # ship class\n");

  HULLSPEC *hullspec;

  hullspec=read_all_hullspec();
  if (!hullspec) {
    fprintf(stderr,"Couldn't open hullspec.dat\n");
    return 1;
  }

  for (int k=1;k<=MAXHULL;k++) {
    if (hullspec[k].sName != "") {
      printf("%3d %s\n",k,(const char *)hullspec[k].sName);
    }
  }

  delete [](hullspec);

  printf("\nMatch list for PLANNUM:\n  # planet name\n");

  PLANET_NAME *planet_name;

  planet_name=read_all_planet_name();
  if (!planet_name) {
    fprintf(stderr,"Couldn't open planet.nm\n");
    return 1;
  }

  for (int k=1;k<=500;k++) {
    if (planet_name[k].sName != "") {
      printf("%3d %s\n",k,(const char *)planet_name[k].sName);
    }
  }

  delete [](planet_name);

  printf("\nMatch list for ENGINE:\n  # engine type\n");

  ENGSPEC *engspec;

  engspec=read_all_engspec();
  if (!engspec) {
    fprintf(stderr,"Couldn't open engspec.dat\n");
    return 1;
  }

  for (int k=1;k<10;k++) {
    if (engspec[k].sName != "") {
      printf("%3d %s\n",k,(const char *)engspec[k].sName);
    }
  }

  delete [](engspec);

  printf("\nMatch list for BEAM:\n  # beam type\n");

  BEAMSPEC *beamspec;

  beamspec=read_all_beamspec();
  if (!beamspec) {
    fprintf(stderr,"Couldn't open beamspec.dat\n");
    return 1;
  }

  for (int k=1;k<=10;k++) {
    if (beamspec[k].sName != "") {
      printf("%3d %s\n",k,(const char *)beamspec[k].sName);
    }
  }

  delete [](beamspec);

  printf("\nMatch list for TORP:\n  # torp type\n");

  TORPSPEC *torpspec;

  torpspec=read_all_torpspec();
  if (!torpspec) {
    fprintf(stderr,"Couldn't open torpspec.dat\n");
    return 1;
  }

  for (int k=1;k<=10;k++) {
    if (torpspec[k].sName != "") {
      printf("%3d %s\n",k,(const char *)torpspec[k].sName);
    }
  }

  delete [](torpspec);

  printf("\nMatch list for MISSION:\n  # mission\n");
  printf("  1 Exploration\n");
  printf("  2 Sweep mines\n");
  printf("  3 Lay mines\n");
  printf("  4 Kill\n");
  printf("  5 Sensor sweep\n");
  printf("  6 Colonise\n");
  printf("  7 Tow\n");
  printf("  8 Intercept\n");
  printf("  9 (race special)\n");
  printf(" 10 Cloak\n");
  printf(" 11 Beam up Fuel\n");
  printf(" 12 Beam up Duranium\n");
  printf(" 13 Beam up Tritanium\n");
  printf(" 14 Beam up Molybdenum\n");
  printf(" 15 Beam up Supplies\n");

  printf("\nMatch list for POWNER:\n  # race\n");

  RACENM *racenm;

  racenm=read_all_racenm();
  if (!racenm) {
    fprintf(stderr,"Couldn't open race.nm\n");
    return 1;
  }

  for (int k=1;k<=11;k++) {
    if (racenm[k].sFull != "") {
      printf("%3d %s\n",k,(const char *)racenm[k].sFull);
    }
  }

  delete [](racenm);

  printf("\nMatch list for PNTYPE:\n  # native type\n");
  printf("  1 Humanoid\n");
  printf("  2 Bovinoid\n");
  printf("  3 Reptilian\n");
  printf("  4 Avian\n");
  printf("  5 Amorphous\n");
  printf("  6 Insectoid\n");
  printf("  7 Amphibian\n");
  printf("  8 Ghipsoldal\n");
  printf("  9 Siliconoid\n");

  return 0;
}
